#!/bin/sh

INSTALL_FILES="animation.png arise-theme.plymouth arise-theme.script background.png box.png bullet.png entry.png install.sh lock.png logo.png motif.png progress_bar.png progress_box.png progress_box_background.png progress_box_edge.png suspend.png"
INSTALL_FOLDER="/use/share/plymouth/themes"
THEME_FOLDER="$INSTALL_FOLDER/arise-theme"

die() {
    echo "$*"
    exit 1
}

mkdir -p "$THEME_FOLDER" || die "Failed to create folder $THEME_FOLDER"
for FILE in $INSTALL_FILES
do
    cp "$FILE" "$THEME_FOLDER/$FILE" || die "Failed to copy file $FILE into $THEME_FOLDER"
done

update-alternatives --install "$INSTALL_FOLDER/default.plymouth" default.plymouth "$THEME_FOLDER/arise-theme.plymouth" 100